/*
 * Code generated from Atmel Start.
 *
 * This file will be overwritten when reconfiguring your Atmel Start project.
 * Please copy examples or other code you want to keep to a separate file
 * to avoid losing it when reconfiguring.
 */

#include "driver_examples.h"
#include "driver_init.h"
#include "utils.h"

/**
 * Example of using ADC_0 to generate waveform.
 */
void ADC_0_example(void)
{
	uint8_t buffer[2];

	adc_sync_enable_channel(&ADC_0, 0);

	while (1) {
		adc_sync_read_channel(&ADC_0, 0, buffer, 2);
	}
}

/**
 * Example of using ADC_1 to generate waveform.
 */
void ADC_1_example(void)
{
	uint8_t buffer[2];

	adc_sync_enable_channel(&ADC_1, 0);

	while (1) {
		adc_sync_read_channel(&ADC_1, 0, buffer, 2);
	}
}

/**
 * Example of using DIGITAL_GLUE_LOGIC_0.
 */
void DIGITAL_GLUE_LOGIC_0_example(void)
{
	custom_logic_enable();
	/* Customer logic now works. */
}

static void button_on_PA07_pressed(void)
{
}

static void button_on_PB30_pressed(void)
{
}

static void button_on_PB31_pressed(void)
{
}

/**
 * Example of using EXTERNAL_IRQ_0
 */
void EXTERNAL_IRQ_0_example(void)
{

	ext_irq_register(PIN_PA07, button_on_PA07_pressed);
	ext_irq_register(PIN_PB30, button_on_PB30_pressed);
	ext_irq_register(PIN_PB31, button_on_PB31_pressed);
}

static uint8_t buf[16] = {0x0};

static void xfer_complete_cb_ECAT_QSPI(struct _dma_resource *resource)
{
	/* Transfer completed */
}

/**
 * Example of using ECAT_QSPI to get N25Q256A status value,
 * and check bit 0 which indicate embedded operation is busy or not.
 */
void ECAT_QSPI_example(void)
{
	struct _qspi_command cmd = {
	    .inst_frame.bits.inst_en      = 1,
	    .inst_frame.bits.data_en      = 1,
	    .inst_frame.bits.addr_en      = 1,
	    .inst_frame.bits.dummy_cycles = 8,
	    .inst_frame.bits.tfr_type     = QSPI_READMEM_ACCESS,
	    .instruction                  = 0x0B,
	    .address                      = 0,
	    .buf_len                      = 14,
	    .rx_buf                       = buf,
	};

	qspi_dma_register_callback(&ECAT_QSPI, QSPI_DMA_CB_XFER_DONE, xfer_complete_cb_ECAT_QSPI);
	qspi_dma_enable(&ECAT_QSPI);
	qspi_dma_serial_run_command(&ECAT_QSPI, &cmd);
}

/**
 * Example of using SPI_1 to write "Hello World" using the IO abstraction.
 */
static uint8_t example_SPI_1[12] = "Hello World!";

void SPI_1_example(void)
{
	struct io_descriptor *io;
	spi_m_sync_get_io_descriptor(&SPI_1, &io);

	spi_m_sync_enable(&SPI_1);
	io_write(io, example_SPI_1, 12);
}

/**
 * Example of using SPI_2 to write "Hello World" using the IO abstraction.
 *
 * Since the driver is asynchronous we need to use statically allocated memory for string
 * because driver initiates transfer and then returns before the transmission is completed.
 *
 * Once transfer has been completed the tx_cb function will be called.
 */

static uint8_t example_SPI_2[12] = "Hello World!";

static void complete_cb_SPI_2(const struct spi_m_async_descriptor *const io_descr)
{
	/* Transfer completed */
}

void SPI_2_example(void)
{
	struct io_descriptor *io;
	spi_m_async_get_io_descriptor(&SPI_2, &io);

	spi_m_async_register_callback(&SPI_2, SPI_M_ASYNC_CB_XFER, (FUNC_PTR)complete_cb_SPI_2);
	spi_m_async_enable(&SPI_2);
	io_write(io, example_SPI_2, 12);
}

/**
 * Example of using SPI_3 to write "Hello World" using the IO abstraction.
 */
static uint8_t example_SPI_3[12] = "Hello World!";

void SPI_3_example(void)
{
	struct io_descriptor *io;
	spi_m_sync_get_io_descriptor(&SPI_3, &io);

	spi_m_sync_enable(&SPI_3);
	io_write(io, example_SPI_3, 12);
}

/**
 * Example of using PWM_0.
 */
void PWM_0_example(void)
{
	pwm_set_parameters(&PWM_0, 10000, 5000);
	pwm_enable(&PWM_0);
}

/**
 * Example of using PWM_1.
 */
void PWM_1_example(void)
{
	pwm_set_parameters(&PWM_1, 10000, 5000);
	pwm_enable(&PWM_1);
}
